# HG changeset patch
# Node ID 79b65daead5f
# Parent  635a129a289d
diff --git a/pidgin/glade/pidgin3.xml.in b/pidgin/glade/pidgin3.xml.in
--- a/pidgin/glade/pidgin3.xml.in
+++ b/pidgin/glade/pidgin3.xml.in
@@ -13,7 +13,6 @@
     <glade-widget-class name="PidginCredentialsPage" generic-name="credentials_page" title="CredentialsPage"/>
     <glade-widget-class name="PidginDialog" generic-name="dialog" title="Dialog"/>
     <glade-widget-class name="PidginInviteDialog" generic-name="invite_dialog" title="InviteDialog"/>
-    <glade-widget-class name="PidginMenuTray" generic-name="menu_tray" title="MenuTray"/>
     <glade-widget-class name="PidginPluginsMenu" generic-name="plugins_menu" title="PluginsMenu"/>
     <glade-widget-class name="PidginPresenceIcon" generic-name="presence_icon" title="PresenceIcon"/>
     <glade-widget-class name="PidginProtocolChooser" generic-name="protocol_chooser" title="ProtocolChooser"/>
@@ -34,7 +33,6 @@
     <glade-widget-class-ref name="PidginCredentialsPage"/>
     <glade-widget-class-ref name="PidginDialog"/>
     <glade-widget-class-ref name="PidginInviteDialog"/>
-    <glade-widget-class-ref name="PidginMenuTray"/>
     <glade-widget-class-ref name="PidginPluginsMenu"/>
     <glade-widget-class-ref name="PidginPresenceIcon"/>
     <glade-widget-class-ref name="PidginProtocolChooser"/>
diff --git a/pidgin/gtkconv.c b/pidgin/gtkconv.c
--- a/pidgin/gtkconv.c
+++ b/pidgin/gtkconv.c
@@ -56,7 +56,6 @@
 #include "pidgingdkpixbuf.h"
 #include "pidgininfopane.h"
 #include "pidgininvitedialog.h"
-#include "pidginmenutray.h"
 #include "pidginmessage.h"
 #include "pidginpresenceicon.h"
 #include "pidginstylecontext.h"
@@ -3515,7 +3514,6 @@
 #include "gtkdialogs.h"
 #include "gtkprivacy.h"
 #include "gtkutils.h"
-#include "pidginmenutray.h"
 
 /**************************************************************************
  * Callbacks
diff --git a/pidgin/meson.build b/pidgin/meson.build
--- a/pidgin/meson.build
+++ b/pidgin/meson.build
@@ -42,7 +42,6 @@
 	'pidginiconname.c',
 	'pidgininfopane.c',
 	'pidgininvitedialog.c',
-	'pidginmenutray.c',
 	'pidginmessage.c',
 	'pidginmooddialog.c',
 	'pidginplugininfo.c',
@@ -102,7 +101,6 @@
 	'pidginiconname.h',
 	'pidgininfopane.h',
 	'pidgininvitedialog.h',
-	'pidginmenutray.h',
 	'pidginmessage.h',
 	'pidginmooddialog.h',
 	'pidginplugininfo.h',
diff --git a/pidgin/pidgincontactlist.c b/pidgin/pidgincontactlist.c
--- a/pidgin/pidgincontactlist.c
+++ b/pidgin/pidgincontactlist.c
@@ -37,8 +37,6 @@
 
 	GtkWidget *plugins;
 	GtkWidget *plugins_menu;
-
-	GtkWidget *menu_tray;
 };
 
 G_DEFINE_TYPE(PidginContactList, pidgin_contact_list,
@@ -64,9 +62,6 @@
 	                          contact_list->accounts_menu);
 	gtk_menu_item_set_submenu(GTK_MENU_ITEM(contact_list->plugins),
 	                          contact_list->plugins_menu);
-
-	gtk_menu_shell_append(GTK_MENU_SHELL(contact_list->menu_bar),
-	                      contact_list->menu_tray);
 }
 
 static void
@@ -92,8 +87,6 @@
 	                                     plugins);
 	gtk_widget_class_bind_template_child(widget_class, PidginContactList,
 	                                     plugins_menu);
-	gtk_widget_class_bind_template_child(widget_class, PidginContactList,
-	                                     menu_tray);
 }
 
 /******************************************************************************
@@ -117,10 +110,3 @@
 
 	return contact_list->sort_buddies;
 }
-
-GtkWidget *
-pidgin_contact_list_get_menu_tray(PidginContactList *contact_list) {
-	g_return_val_if_fail(PIDGIN_IS_CONTACT_LIST(contact_list), NULL);
-
-	return contact_list->menu_tray;
-}
diff --git a/pidgin/pidginmenutray.h b/pidgin/pidginmenutray.h
deleted file mode 100644
--- a/pidgin/pidginmenutray.h
+++ /dev/null
@@ -1,92 +0,0 @@
-/* Pidgin is the legal property of its developers, whose names are too numerous
- * to list here.  Please refer to the COPYRIGHT file distributed with this
- * source distribution.
- *
- * This program is free software; you can redistribute it and/or modify
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111-1301  USA
- */
-
-#if !defined(PIDGIN_GLOBAL_HEADER_INSIDE) && !defined(PIDGIN_COMPILATION)
-# error "only <pidgin.h> may be included directly"
-#endif
-
-#ifndef PIDGIN_MENU_TRAY_H
-#define PIDGIN_MENU_TRAY_H
-
-#include <gtk/gtk.h>
-
-G_BEGIN_DECLS
-
-#define PIDGIN_TYPE_MENU_TRAY (pidgin_menu_tray_get_type())
-G_DECLARE_FINAL_TYPE(PidginMenuTray, pidgin_menu_tray, PIDGIN, MENU_TRAY, GtkMenuItem)
-
-/**
- * PidginMenuTray:
- *
- * A PidginMenuTray is a #GtkMenuItem that allows you to pack icons into it
- * similar to a system notification area but in a windows menu bar.
- */
-
-/**
- * pidgin_menu_tray_new:
- *
- * Creates a new PidginMenuTray
- *
- * Returns: A new PidginMenuTray
- */
-GtkWidget *pidgin_menu_tray_new(void);
-
-/**
- * pidgin_menu_tray_get_box:
- * @menu_tray: The PidginMenuTray
- *
- * Gets the box for the PidginMenuTray
- *
- * Returns: (transfer none): The box that this menu tray is using
- */
-GtkWidget *pidgin_menu_tray_get_box(PidginMenuTray *menu_tray);
-
-/**
- * pidgin_menu_tray_append:
- * @menu_tray: The tray
- * @widget:    The widget
- * @tooltip:   The tooltip for this widget
- *
- * Appends a widget into the tray
- */
-void pidgin_menu_tray_append(PidginMenuTray *menu_tray, GtkWidget *widget, const char *tooltip);
-
-/**
- * pidgin_menu_tray_prepend:
- * @menu_tray: The tray
- * @widget:    The widget
- * @tooltip:   The tooltip for this widget
- *
- * Prepends a widget into the tray
- */
-void pidgin_menu_tray_prepend(PidginMenuTray *menu_tray, GtkWidget *widget, const char *tooltip);
-
-/**
- * pidgin_menu_tray_set_tooltip:
- * @menu_tray: The tray
- * @widget:    The widget
- * @tooltip:   The tooltip to set for the widget
- *
- * Set the tooltip for a widget
- */
-void pidgin_menu_tray_set_tooltip(PidginMenuTray *menu_tray, GtkWidget *widget, const char *tooltip);
-
-G_END_DECLS
-
-#endif /* PIDGIN_MENU_TRAY_H */
diff --git a/pidgin/pidginmenutray.c b/pidgin/pidginmenutray.c
deleted file mode 100644
--- a/pidgin/pidginmenutray.c
+++ /dev/null
@@ -1,201 +0,0 @@
-/*
- * Pidgin is the legal property of its developers, whose names are too numerous
- * to list here.  Please refer to the COPYRIGHT file distributed with this
- * source distribution.
- *
- * This program is free software; you can redistribute it and/or modify
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111-1301  USA
- */
-
-#include "pidginmenutray.h"
-
-struct _PidginMenuTray {
-	GtkMenuItem parent;
-
-	GtkWidget *tray;
-};
-
-enum {
-	PROP_ZERO = 0,
-	PROP_BOX,
-	N_PROPERTIES
-};
-
-/******************************************************************************
- * Globals
- *****************************************************************************/
-static GParamSpec *properties[N_PROPERTIES] = {NULL, };
-
-/******************************************************************************
- * Item Stuff
- *****************************************************************************/
-static void
-pidgin_menu_tray_select(GtkMenuItem *widget) {
-	/* this may look like nothing, but it's really overriding the
-	 * GtkMenuItem's select function so that it doesn't get highlighted like
-	 * a normal menu item would.
-	 */
-}
-
-static void
-pidgin_menu_tray_deselect(GtkMenuItem *widget) {
-	/* Probably not necessary, but I'd rather be safe than sorry.  We're
-	 * overriding the select, so it makes sense to override deselect as well.
-	 */
-}
-
-/******************************************************************************
- * GObject Implementation
- *****************************************************************************/
-G_DEFINE_TYPE(PidginMenuTray, pidgin_menu_tray, GTK_TYPE_MENU_ITEM);
-
-static void
-pidgin_menu_tray_get_property(GObject *obj, guint param_id, GValue *value,
-                              GParamSpec *pspec)
-{
-	PidginMenuTray *menu_tray = PIDGIN_MENU_TRAY(obj);
-
-	switch(param_id) {
-		case PROP_BOX:
-			g_value_set_object(value, pidgin_menu_tray_get_box(menu_tray));
-			break;
-		default:
-			G_OBJECT_WARN_INVALID_PROPERTY_ID(obj, param_id, pspec);
-			break;
-	}
-}
-
-static void
-pidgin_menu_tray_map(GtkWidget *widget) {
-	GTK_WIDGET_CLASS(pidgin_menu_tray_parent_class)->map(widget);
-
-	gtk_container_add(GTK_CONTAINER(widget), PIDGIN_MENU_TRAY(widget)->tray);
-}
-
-static void
-pidgin_menu_tray_class_init(PidginMenuTrayClass *klass) {
-	GObjectClass *obj_class = G_OBJECT_CLASS(klass);
-	GtkMenuItemClass *menu_item_class = GTK_MENU_ITEM_CLASS(klass);
-	GtkWidgetClass *widget_class = GTK_WIDGET_CLASS(klass);
-
-	obj_class->get_property = pidgin_menu_tray_get_property;
-
-	menu_item_class->select = pidgin_menu_tray_select;
-	menu_item_class->deselect = pidgin_menu_tray_deselect;
-
-	widget_class->map = pidgin_menu_tray_map;
-
-	properties[PROP_BOX] = g_param_spec_object("box", "The box", "The box",
-	                                           GTK_TYPE_BOX,
-	                                           G_PARAM_READABLE | G_PARAM_STATIC_STRINGS);
-
-	g_object_class_install_properties(obj_class, N_PROPERTIES, properties);
-}
-
-static void
-pidgin_menu_tray_init(PidginMenuTray *menu_tray) {
-	GtkWidget *widget = GTK_WIDGET(menu_tray);
-	gint height = -1;
-
-G_GNUC_BEGIN_IGNORE_DEPRECATIONS
-	/* Gtk3 docs says, it should be replaced with gtk_widget_set_hexpand and
-	 * gtk_widget_set_halign. But it doesn't seems to work. */
-	gtk_menu_item_set_right_justified(GTK_MENU_ITEM(menu_tray), TRUE);
-G_GNUC_END_IGNORE_DEPRECATIONS
-
-	if(!GTK_IS_WIDGET(menu_tray->tray)) {
-		menu_tray->tray = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
-	}
-
-	if(gtk_icon_size_lookup(GTK_ICON_SIZE_MENU, NULL, &height)) {
-		gtk_widget_set_size_request(widget, -1, height);
-	}
-
-	gtk_widget_show(menu_tray->tray);
-}
-
-/******************************************************************************
- * API
- *****************************************************************************/
-GtkWidget *
-pidgin_menu_tray_new() {
-	return g_object_new(PIDGIN_TYPE_MENU_TRAY, NULL);
-}
-
-GtkWidget *
-pidgin_menu_tray_get_box(PidginMenuTray *menu_tray) {
-	g_return_val_if_fail(PIDGIN_IS_MENU_TRAY(menu_tray), NULL);
-
-	return menu_tray->tray;
-}
-
-static void
-pidgin_menu_tray_add(PidginMenuTray *menu_tray, GtkWidget *widget,
-					   const char *tooltip, gboolean prepend)
-{
-	g_return_if_fail(PIDGIN_IS_MENU_TRAY(menu_tray));
-	g_return_if_fail(GTK_IS_WIDGET(widget));
-
-	if (!gtk_widget_get_has_window(widget)) {
-		GtkWidget *event;
-
-		event = gtk_event_box_new();
-		gtk_container_add(GTK_CONTAINER(event), widget);
-		gtk_widget_show(event);
-		widget = event;
-	}
-
-	pidgin_menu_tray_set_tooltip(menu_tray, widget, tooltip);
-
-	if (prepend) {
-		gtk_box_pack_start(GTK_BOX(menu_tray->tray), widget, FALSE, FALSE, 0);
-	} else {
-		gtk_box_pack_end(GTK_BOX(menu_tray->tray), widget, FALSE, FALSE, 0);
-	}
-}
-
-void
-pidgin_menu_tray_append(PidginMenuTray *menu_tray, GtkWidget *widget,
-                        const char *tooltip)
-{
-	pidgin_menu_tray_add(menu_tray, widget, tooltip, FALSE);
-}
-
-void
-pidgin_menu_tray_prepend(PidginMenuTray *menu_tray, GtkWidget *widget,
-                         const char *tooltip)
-{
-	pidgin_menu_tray_add(menu_tray, widget, tooltip, TRUE);
-}
-
-void
-pidgin_menu_tray_set_tooltip(PidginMenuTray *menu_tray, GtkWidget *widget,
-                             const char *tooltip)
-{
-	/* Should we check whether widget is a child of menu_tray? */
-
-	/*
-	 * If the widget does not have its own window, then it
-	 * must have automatically been added to an event box
-	 * when it was added to the menu tray.  If this is the
-	 * case, we want to set the tooltip on the widget's parent,
-	 * not on the widget itself.
-	 */
-	if (!gtk_widget_get_has_window(widget)) {
-		widget = gtk_widget_get_parent(widget);
-	}
-
-	gtk_widget_set_tooltip_text(widget, tooltip);
-}
-
diff --git a/pidgin/resources/BuddyList/window.ui b/pidgin/resources/BuddyList/window.ui
--- a/pidgin/resources/BuddyList/window.ui
+++ b/pidgin/resources/BuddyList/window.ui
@@ -345,11 +345,6 @@
     <property name="visible">True</property>
     <property name="can-focus">False</property>
   </object>
-  <object class="PidginMenuTray" id="menu_tray">
-    <property name="visible">True</property>
-    <property name="can-focus">False</property>
-    <property name="right-justified">True</property>
-  </object>
   <object class="PidginPluginsMenu" id="plugins_menu">
     <property name="visible">True</property>
     <property name="can-focus">False</property>
diff --git a/po/POTFILES.in b/po/POTFILES.in
--- a/po/POTFILES.in
+++ b/po/POTFILES.in
@@ -344,7 +344,6 @@
 pidgin/pidginiconname.c
 pidgin/pidgininfopane.c
 pidgin/pidgininvitedialog.c
-pidgin/pidginmenutray.c
 pidgin/pidginmessage.c
 pidgin/pidginmooddialog.c
 pidgin/pidginplugininfo.c
